
Below are some sample commands to run the code

For CIFAR100 - 

ICAL:
python -W ignore ical/src/run_experiment.py --fix_numpy_python_seed --cudnn_deterministic --batch_size 64 --seed 661442 --dataset cifar100 --initial_samples_per_class 200 --num_inference_samples 288 --available_sample_k 3000 --validation_set_size 1024 --early_stopping_patience 6 --target_num_acquired_samples 21000 --epoch_samples 5056 --initial_percentage 100 --ical_max_greedy_iterations 0 --hsic_compute_batch_size 4000 --num_to_condense 200 --max_batch_compute_size 1 --acquisition_method icalscale --gpu 0 --experiment_task_id cifar100_icalscale_g3000_k288_b3000_661442_60_200_fix --epochs 60

ICAL-pointwise:
python -W ignore ical/src/run_experiment.py --fix_numpy_python_seed --cudnn_deterministic --batch_size 64 --seed 661442 --dataset cifar --initial_samples_per_class 1000 --target_num_acquired_samples 30000 --num_inference_samples 130 --available_sample_k 3000 --validation_set_size 512 --early_stopping_patience 6 --epoch_samples 5056 --num_to_condense 200 --hsic_compute_batch_size 500 --acquisition_method icalpointwise --gpu 1 --experiment_task_id cifar_icalpointwise_it15_new_k130_b3000_661442_40_1000 --epochs 50 --max_batch_compute_size 200 --num_inference_for_marginal_stat 40 --ical_max_greedy_iterations 15

Max Entropy:
python -W ignore ical/src/run_experiment.py --fix_numpy_python_seed --cudnn_deterministic --batch_size 64 --seed 88888 --dataset cifar100 --initial_samples_per_class 200 --num_inference_samples 288 --available_sample_k 3000 --validation_set_size 1024 --early_stopping_patience 6 --target_num_acquired_samples 21000 --epoch_samples 5056 --initial_percentage 100 --hsic_compute_batch_size 800 --acquisition_method independent --type predictive_entropy --gpu 1 --experiment_task_id cifar100_independent_predictive_entropy_k288_b3000_88888_60_200_fix --epochs 60

FASS:
python -W ignore ical/src/run_experiment.py --fix_numpy_python_seed --cudnn_deterministic --batch_size 64 --seed 88888 --dataset cifar100 --initial_samples_per_class 200 --num_inference_samples 288 --available_sample_k 3000 --validation_set_size 1024 --early_stopping_patience 6 --target_num_acquired_samples 21000 --epoch_samples 5056 --initial_percentage 100 --hsic_compute_batch_size 5 --max_batch_compute_size 50 --acquisition_method fass --gpu 0 --experiment_task_id cifar100_fass_k288_b3000_88888_60_200_fix --epochs 60

Bayesian Coreset approach/ACS-FW:
python -W ignore ical/src/run_experiment.py --fix_numpy_python_seed --cudnn_deterministic --batch_size 64 --seed 666666 --dataset cifar100 --initial_samples_per_class 200 --num_inference_samples 288 --available_sample_k 3000 --validation_set_size 1024 --early_stopping_patience 6 --target_num_acquired_samples 21000 --epoch_samples 5056 --initial_percentage 100 --ical_max_greedy_iterations 0 --hsic_compute_batch_size 4000 --num_to_condense 200 --max_batch_compute_size 1 --acquisition_method acsfw --gpu 1 --experiment_task_id cifar100_acsfw_g3000_k288_b3000_666666_60_200_fix --epochs 60

Badge:
python -W ignore badge/src-badge/run_experiment.py --fix_numpy_python_seed --cudnn_deterministic --batch_size 64 --seed 452093 --dataset cifar --initial_samples_per_class 1000 --num_inference_samples 130 --available_sample_k 3000 --validation_set_size 512 --early_stopping_patience 6 --target_num_acquired_samples 30000 --epoch_samples 5056 --initial_percentage 100 --acquisition_method badge --gpu 7 --experiment_task_id cifar_badge_k130_b3000_452093_40_1000_fix --epochs 50 (edited) 

Random:
python -W ignore ical/src/run_experiment.py --fix_numpy_python_seed --cudnn_deterministic --batch_size 64 --seed 88888 --dataset cifar100 --initial_samples_per_class 200 --num_inference_samples 288 --available_sample_k 3000 --validation_set_size 1024 --early_stopping_patience 6 --target_num_acquired_samples 21000 --epoch_samples 5056 --initial_percentage 100 --hsic_compute_batch_size 800 --acquisition_method independent --type random --gpu 2 --experiment_task_id cifar100_independent_random_k288_b3000_88888_60_200_fix --epochs 60


EMNIST: 

python -W ignore badge/src/run_experiment.py --batch_size 64 --seed 218487 --dataset emnist --initial_samples_per_class 2 --num_inference_samples 50 --num_inference_samples_acq 1 --available_sample_k 5   --acquisition_method badge --gpu 0 --scoring_batch_size 512 --test_batch_size 512 --validation_set_size 16384 --early_stopping_patience 3 --epoch_samples 20224 --target_num_acquired_samples 255     --experiment_task_id emnist_badge_k50_b5_218487_40_2 --epochs 40